<template>
  <div class="tenant">
    <!-- <Banner /> -->
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :selectConfig="selectConfig"
        :table-events="{
          //element talbe事件都能传
          select: select,
        }"
        :action-list="[
          {
            text: '添加仓库',
            action: () => openModal('add'),
          },
        ]"
        @get-list="getList"
      >
        <template #slotName="{ item }">
          {{ item.createTime }}
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '添加仓库' : '编辑'"
      v-model="dialogVisible"
      width="800"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>

    <el-dialog
      title="库位维护"
      v-model="dialogVisibleOne"
      width="800"
      v-loading="loadingOne"
      destroy-on-close
    >
      <byForm
        :formConfig="formConfigOne"
        :formOption="formOption"
        v-model="formData.dataOne"
        :rules="rulesOne"
        ref="byformOne"
      >
        <template #slot>
          <div style="width: 100%">
            <el-button type="primary" @click="clickAdd">添 加</el-button>
            <el-table
              :data="formData.dataOne.warehouseLocationInfoList"
              style="width: 100%; margin-top: 16px"
            >
              <el-table-column label="库位编码" width="150">
                <template #default="{ row, $index }">
                  <div style="width: 100%">
                    <el-form-item
                      :prop="'warehouseLocationInfoList.' + $index + '.code'"
                      :rules="rulesOne.code"
                      :inline-message="true"
                    >
                      <el-input v-model="row.code" placeholder="请输入" />
                    </el-form-item>
                  </div>
                </template>
              </el-table-column>
              <el-table-column label="库位名称" width="150">
                <template #default="{ row, $index }">
                  <div style="width: 100%">
                    <el-form-item
                      :prop="'warehouseLocationInfoList.' + $index + '.name'"
                      :rules="rulesOne.name"
                      :inline-message="true"
                    >
                      <el-input v-model="row.name" placeholder="请输入" />
                    </el-form-item>
                  </div>
                </template>
              </el-table-column>
              <el-table-column label="绑定物品">
                <template #default="{ row, $index }">
                  <div style="width: 100%">
                    <el-form-item
                      :prop="
                        'warehouseLocationInfoList.' + $index + '.productIds'
                      "
                      :rules="rulesOne.productIds"
                      :inline-message="true"
                    >
                      <el-select
                        v-model="row.productIds"
                        placeholder="请选择绑定物品"
                        style="width: 100%"
                        multiple
                      >
                        <el-option
                          v-for="item in productList"
                          :key="item.id"
                          :label="item.name"
                          :value="item.id"
                        />
                      </el-select>
                    </el-form-item>
                  </div>
                </template>
              </el-table-column>

              <el-table-column
                align="center"
                label="操作"
                width="80"
                fixed="right"
              >
                <template #default="{ $index }">
                  <el-button type="primary" link @click="clickDelete($index)"
                    >删除</el-button
                  >
                </template>
              </el-table-column>
            </el-table>
          </div>
        </template>
      </byForm>
      <template #footer>
        <el-button @click="dialogVisibleOne = false" size="large"
          >取 消</el-button
        >
        <el-button
          type="primary"
          @click="submitFormOne('byform')"
          size="large"
          :loading="loadingOne"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
  </div>
</template>
  
<script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { computed, defineComponent, ref } from "vue";
import useUserStore from "@/store/modules/user";

const loading = ref(false);
const loadingOne = ref(false);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let dialogVisibleOne = ref(false);
let roomDialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  type: [
    { required: true, message: "请选择仓库类型", trigger: ["blur", "change"] },
  ],
  name: [{ required: true, message: "请输入仓库名称", trigger: "blur" }],
});
let rulesOne = ref({
  code: [{ required: true, message: "请输入库位编码", trigger: "blur" }],
  name: [{ required: true, message: "请输入库位名称", trigger: "blur" }],
  productIds: [{ required: true, message: "请绑定物品", trigger: "change" }],
});
const { proxy } = getCurrentInstance();
const warehouseType = ref([]);
const productList = ref([]);
const selectConfig = computed(() => [
  {
    label: "仓库类型",
    prop: "type",
    data: warehouseType.value,
  },
]);

const config = computed(() => {
  return [
    {
      attrs: {
        label: "仓库类型",
        prop: "type",
      },
      render(type) {
        return proxy.dictValueLabel(type, warehouseType.value);
      },
    },
    {
      attrs: {
        label: "仓库名称",
        prop: "name",
      },
    },
    {
      attrs: {
        label: "仓管员",
        prop: "keeperName",
      },
    },
    {
      attrs: {
        label: "备注",
        prop: "remark",
      },
    },
    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "库位维护",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtlOne(row);
            },
          },
          {
            attrs: {
              label: "修改",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "删除",
              type: "danger",
              text: true,
            },
            el: "button",
            click() {
              // 弹窗提示是否删除
              ElMessageBox.confirm(
                "此操作将永久删除该数据, 是否继续?",
                "提示",
                {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "warning",
                }
              ).then(() => {
                // 删除
                proxy
                  .post("/warehouse/delete", {
                    id: row.id,
                  })
                  .then((res) => {
                    ElMessage({
                      message: "删除成功",
                      type: "success",
                    });
                    getList();
                  });
              });
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {},
  dataOne: {},
  treeData: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const byformOne = ref(null);

const treeData = ref([]);
const formConfig = computed(() => [
  {
    type: "select",
    prop: "type",
    label: "仓库类型",
    required: true,
    data: warehouseType.value,
  },
  {
    type: "input",
    prop: "name",
    label: "仓库名称",
  },
  {
    type: "select",
    prop: "keeperId",
    label: "仓管员",
    isLoad: {
      url: `/tenantUser/list?pageNum=1&pageSize=9999&tenantId=${
        useUserStore().user.tenantId
      }`,
      labelKey: "nickName",
      labelVal: "userId",
      method: "get",
      resUrl: "rows",
    },
  },
  {
    type: "input",
    itemType: "textarea",
    prop: "remark",
    label: "备注",
  },
]);
const formConfigOne = reactive([
  {
    type: "title",
    title: "仓库信息",
  },
  {
    type: "input",
    prop: "name",
    label: "仓库名称",
    disabled: true,
  },
  {
    type: "select",
    prop: "keeperId",
    label: "仓管员",
    disabled: true,
    isLoad: {
      url: `/tenantUser/list?pageNum=1&pageSize=9999&tenantId=${
        useUserStore().user.tenantId
      }`,
      labelKey: "nickName",
      labelVal: "userId",
      method: "get",
      resUrl: "rows",
    },
  },
  {
    type: "slot",
    slotName: "slot",
    label: "库位信息",
  },
]);
const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy.post("/warehouse/page", sourceList.value.pagination).then((message) => {
    console.log(message);
    sourceList.value.data = message.rows;
    sourceList.value.pagination.total = message.total;
    setTimeout(() => {
      loading.value = false;
    }, 200);
  });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {};
};

const submitForm = () => {
  byform.value.handleSubmit((valid) => {
    submitLoading.value = true;
    proxy.post("/warehouse/" + modalType.value, formData.data).then(
      (res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => (submitLoading.value = false)
    );
  });
};

const submitFormOne = () => {
  byformOne.value.handleSubmit((valid) => {
    if (formData.dataOne.warehouseLocationInfoList.length > 0) {
      const oldList = formData.dataOne.warehouseLocationInfoList;
      const list = formData.dataOne.warehouseLocationInfoList;
      for (let i = 0; i < list.length; i++) {
        const e = list[i];
        e.productIds = e.productIds.join(",");
      }
      formData.dataOne.warehouseLocationInfoList = list;
      loadingOne.value = true;
      proxy.post("/warehouseLocationInfo/edit", formData.dataOne).then(
        (res) => {
          ElMessage({
            message: "操作成功",
            type: "success",
          });
          dialogVisibleOne.value = false;
          loadingOne.value = false;
          getList();
        },
        (err) => {
          loadingOne.value = false;
          formData.dataOne.warehouseLocationInfoList = oldList;
        }
      );
    } else {
      return ElMessage({
        message: "请添加库位信息",
        type: "info",
      });
    }
  });
};

const getDtl = (row) => {
  modalType.value = "edit";
  proxy.post("/warehouse/detail", { id: row.id }).then((res) => {
    res.type = res.type + "";
    dialogVisible.value = true;
    formData.data = res;
  });
};
const getDtlOne = (row) => {
  proxy
    .post("/warehouseLocationInfo/list", { warehouseId: row.id })
    .then((res) => {
      for (let i = 0; i < res.length; i++) {
        const e = res[i];
        if (e.productIds) {
          e.productIds = e.productIds.split(",");
        }
      }
      formData.dataOne = {
        warehouseId: row.id,
        name: row.name,
        keeperId: row.keeperId,
        warehouseLocationInfoList: res,
      };
      dialogVisibleOne.value = true;
    });
};

const getDict = () => {
  proxy.getDictOne(["warehouse_type"]).then((res) => {
    warehouseType.value = res["warehouse_type"].map((x) => ({
      label: x.dictValue,
      value: x.dictKey,
    }));
  });
  proxy
    .post("/productInfo/page", {
      pageNum: 1,
      pageSize: 99999,
      definition: "",
    })
    .then((res) => {
      productList.value = res.rows;
    });
};
getList();
getDict();

const clickAdd = () => {
  formData.dataOne.warehouseLocationInfoList.push({
    code: "",
    name: "",
    productIds: [],
  });
};
const clickDelete = (index) => {
  formData.dataOne.warehouseLocationInfoList.splice(index, 1);
};
</script>
  
<style lang="scss" scoped>
.tenant {
  padding: 20px;
}
.by-form .el-form--inline .el-form-item {
  padding-right: 0px;
}
</style>